<?php
/*
	Plugin Name: Iranian Calender
	Plugin URI: http://sasy.ir/wordpress-plugins/iranian-calendar/
	Description: This plugin converts gregorian calendar to iranian solar calendar
	Version: 0.0.1
	Author: Sasan S
	Lience: GPL3
*/
?>
<?php
	define('IRCAL_DIR', __DIR__);
	require_once(IRCAL_DIR.'/libs/jalali-core.php');
	require_once(IRCAL_DIR.'/libs/farsinum-core.php');

	add_action ('admin_init', 'ircal_settings_api_init');
	function ircal_settings_api_init() {
		register_setting ('ircal_options', 'ircal_field_datecon');
		register_setting ('ircal_options', 'ircal_field_uricon');
		register_setting ('ircal_options', 'ircal_field_county');
		add_settings_section ('ircal_settings_section', 'General Settings', 'ircal_settings_section_callback','iranian-cal');
		add_settings_field ('ircal_field_datecon','Date covertion in Post & Comments','ircal_field_datecon_callback','iranian-cal', 'ircal_settings_section');
		add_settings_field ('ircal_field_uricon','URI Convertion','ircal_field_uricon_callback','iranian-cal', 'ircal_settings_section');
		add_settings_field ('ircal_field_county','Country Month','ircal_field_county_callback','iranian-cal', 'ircal_settings_section');
	}
 	function ircal_settings_section_callback() {
		//echo 'this where our section started';
	}

	function ircal_field_datecon_callback() {
		echo '<select name ="ircal_field_datecon">
				<option value="enable"' . selected(get_option('ircal_field_datecon'), "enable", false) . '>Enable</option>
				<option value="disable"' . selected(get_option('ircal_field_datecon'), "disable", false) . '>Disable</option>
			</select>';
	}

	function ircal_field_uricon_callback() {
		echo '<select name ="ircal_field_uricon">
				<option value="enable"' . selected(get_option('ircal_field_uricon'), "enable", false) . '>Enable</option>
				<option value="disable"' . selected(get_option('ircal_field_uricon'), "disable", false) . '>Disable</option>
			</select>';
	}
	function ircal_field_county_callback() {
		echo '<select name ="ircal_field_county">
				<option value="ir"' . selected(get_option('ircal_field_county'), "ir", false) . '>Iran</option>
				<option value="af"' . selected(get_option('ircal_field_county'), "af", false) . '>Afghanistan</option>
			</select>';
		}

	add_action ('admin_menu','my_plugin_menu');
	function my_plugin_menu() {
		add_options_page('Oh Yeah! my first plugin', 'Iranian Cal', 'manage_options', 'iranian-cal','my_plugin_page');
	}
	function my_plugin_page() {
		?>
		<div class="wrap">
		<h2>Iranian Calendar Options</h2>
		<form method="post" action="options.php">
		<?php settings_fields ('ircal_options'); ?>
		<?php do_settings_sections ('iranian-cal'); ?>
		<?php submit_button(); ?>
		</form>
		</div>
		<?php
	}

/* Functions */
	function ircal_maketimestamp($m) {
		return mktime(substr($m,11,2),substr($m,14,2),substr($m,17,2),substr($m,5,2),substr($m,8,2),substr($m,0,4));
	}

	function ircal_irdate($input,$d='',$before='', $after='') {
		global $id, $post, $day, $previousday, $newday;
		$result = '';
		if ($d == "") $d = get_option('time_format');
		if (strlen($input) > 0) {
			$m = $post->post_date;
			$timestamp = ircal_maketimestamp($m);
			$result .= $before;
			$result .= jdate($d,$timestamp);
			$result .= $after;
			$previousday = $day;
		}
		return $result;
	}
	function ircal_irtime($input,$d='') {
		global $id, $post;
		if (!empty($input)){
			if ($d == "") $d = get_option('time_format');
			$m = $post->post_date;
			$timestamp = ircal_maketimestamp($m);
			$the_time = jdate($d, $timestamp);
			return $the_time;
		}
	}

	function ircal_commentdate($input, $d = '') {
		global $comment;
		$result = '';
		$m = $comment->comment_date;
		$timestamp = ircal_maketimestamp($m);
		if ( '' == $d )
			$result = jdate(get_option('date_format'), $timestamp);
		else
			$result = jdate($d, $timestamp);
		return $result;
	}

	function ircal_commenttime($input, $d = '') {
		global $comment;
		$result = '';
		$m = $comment->comment_date;
		$timestamp = ircal_maketimestamp($m);
		if ( '' == $d )
			$result = jdate(get_option('time_format'), $timestamp);
		else
			$result = jdate($d, $timestamp);
		return  $result;
	}
	function pashm1($input) {
		return "1390";
	}

/* Core Changes */
if ("enable" == get_option('ircal_field_datecon')) {
	add_filter("the_date","ircal_irdate",10,4);
	add_filter("the_time","ircal_irtime",10,4);
	add_filter("get_comment_date","ircal_commentdate",10,2);
	add_filter("get_comment_time","ircal_commenttime",10,2);
}

?>
